Index: Makefile
===================================================================
--- Makefile	(revision 1451)
+++ Makefile	(revision 1581)
@@ -11,5 +11,5 @@
 	
 	## Copy needed folders and files
-	cp -pRf ./admin ./inc ./themes ./index.php ./CHANGELOG ./CREDITS ./LICENSE ./README ./$(DC)/
+	cp -pRf ./admin ./inc ./themes ./index.php ./CHANGELOG ./CREDITS ./LICENSE ./README.md ./CONTRIBUTING.md ./$(DC)/
 	
 	## Locales directory
@@ -88,5 +88,5 @@
 
 deb:
-	cp ./README debian/README
+	cp ./README.md debian/README
 	dpkg-buildpackage -rfakeroot
 
Index: admin/auth.php
===================================================================
--- admin/auth.php	(revision 1484)
+++ admin/auth.php	(revision 1558)
@@ -324,5 +324,5 @@
 }
 if ($msg) {
-	echo '<p class="message">'.$msg.'</p>';
+	echo '<p class="success">'.$msg.'</p>';
 }
 
@@ -396,5 +396,5 @@
 		__('Remember my ID on this computer').'</label></p>'.
 		
-		'<p><input class="add button" type="submit" value="'.__('log in').'" /></p>';
+		'<p><input type="submit" value="'.__('log in').'" class="login" /></p>';
 		
 		if (!empty($_REQUEST['blog'])) {
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 1499)
+++ admin/blog_pref.php	(revision 1553)
@@ -290,9 +290,9 @@
 {
 	if (!empty($_GET['add'])) {
-		dcPage::message(__('Blog has been successfully created.'));
+		dcPage::success(__('Blog has been successfully created.'));
 	}
 	
 	if (!empty($_GET['upd'])) {
-		dcPage::message(__('Blog has been successfully updated.'));
+		dcPage::success(__('Blog has been successfully updated.'));
 	}
 	
Index: admin/blog_theme.php
===================================================================
--- admin/blog_theme.php	(revision 1526)
+++ admin/blog_theme.php	(revision 1553)
@@ -233,13 +233,13 @@
 {
 	if (!empty($_GET['upd'])) {
-		dcPage::message(__('Theme has been successfully changed.'));
+		dcPage::success(__('Theme has been successfully changed.'));
 	}
 	
 	if (!empty($_GET['added'])) {
-		dcPage::message(($_GET['added'] == 2 ? __('Theme has been successfully upgraded') : __('Theme has been successfully installed.')));
+		dcPage::success(($_GET['added'] == 2 ? __('Theme has been successfully upgraded') : __('Theme has been successfully installed.')));
 	}
 	
 	if (!empty($_GET['del'])) {
-		dcPage::message(__('Theme has been successfully deleted.'));
+		dcPage::success(__('Theme has been successfully deleted.'));
 	}
 	
Index: admin/blogs.php
===================================================================
--- admin/blogs.php	(revision 1514)
+++ admin/blogs.php	(revision 1553)
@@ -82,5 +82,5 @@
 
 if (!empty($_GET['del'])) {
-	dcPage::message(__('Blog has been successfully deleted.'));
+	dcPage::success(__('Blog has been successfully deleted.'));
 }
 
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 1525)
+++ admin/categories.php	(revision 1576)
@@ -17,23 +17,53 @@
 # Remove a categories
 if (!empty($_POST['categories'])) {
-	$error = false;
-	foreach ($_POST['categories'] as $cat_id) {
-		# Check if category to delete exists
-		$c = $core->blog->getCategory((integer) $cat_id);
-		if ($c->isEmpty()) {
-			continue;
-		}
-		unset($c);
-
-		try {
+	try {
+		# Check if category where to move posts exists
+		$mov_cat = (int) $_POST['mov_cat'];
+		$mov_cat = $mov_cat ? $mov_cat : null;
+		if ($mov_cat !== null) {
+			$c = $core->blog->getCategory($mov_cat);
+			if ($c->isEmpty()) {
+				throw new Exception(__('Category where to move posts does not exist'));
+			}
+			unset($c);
+
+			if (in_array($mov_cat, $_POST['categories'])) {
+				throw new Exception(__('The entries cannot be moved to the category you choose to delete.'));
+			}
+		}
+
+		foreach ($_POST['categories'] as $cat_id) {
+			# Check if category to delete exists
+			$c = $core->blog->getCategory((integer) $cat_id);
+			if ($c->isEmpty()) {
+				continue;
+			}
+			unset($c);
+
+			# Move posts
+			if ($mov_cat != $cat_id) {
+			        $core->blog->changePostsCategory($cat_id,$mov_cat);
+			}
+
 			# Delete category
 			$core->blog->delCategory($cat_id);
-		} catch (Exception $e) {
-			$error = true;
-		}
-	}
-	if (!$error) {
+		}
 		http::redirect('categories.php?del='.count($_POST['categories']));
-	}
+	} catch (Exception $e) {
+		$core->error->add($e->getMessage());
+	}
+}
+
+# Update order
+if (!empty($_POST['categories_order']))
+{
+        $categories = json_decode($_POST['categories_order']);
+
+	foreach ($categories as $category) {
+	        if (!empty($category->item_id)) {
+		        $core->blog->updCategoryPosition($category->item_id, $category->left, $category->right);
+		}
+	}
+	http::redirect('categories.php?reord=1');
 }
 
@@ -52,19 +82,19 @@
 }
 
-# Actions combo box
-$combo_action = array();
-if ($core->auth->check('categories',$core->blog->id)) {
-	$combo_action[__('Delete')] = 'delete';
-}
-
-# --BEHAVIOR-- adminCategoriesActionsCombo
-$core->callBehavior('adminCategoriesActionsCombo',array(&$combo_action));
-
 
 /* Display
 -------------------------------------------------------- */
-dcPage::open(__('Categories'),
-	dcPage::jsToolMan()."\n".
-	dcPage::jsLoad('js/_categories.js'),
+$rs = $core->blog->getCategories(array('post_type'=>'post'));
+
+$starting_script = dcPage::jsToolMan()."\n";
+if (!$core->auth->user_prefs->accessibility->nodragdrop
+	&& $core->auth->check('categories',$core->blog->id)
+	&& $rs->count()>1) {
+        $starting_script .= dcPage::jsLoad('js/jquery/jquery-ui.custom.js');
+	$starting_script .= dcPage::jsLoad('js/jquery/jquery.mjs.nestedSortable.js');
+}
+$starting_script .= dcPage::jsLoad('js/_categories.js');
+
+dcPage::open(__('Categories'),$starting_script,
 	dcPage::breadcrumb(
 		array(
@@ -74,22 +104,14 @@
 );
 
-if (!empty($_GET['add'])) {
-	dcPage::message(__('The category has been successfully created.'));
-}
 if (!empty($_GET['del'])) {
-  dcPage::message(__('The category has been successfully removed.',
-		     'The categories have been successfully removed.',
-		     (int) $_GET['del']
-		     )
-		  );
+        dcPage::success(__('The category has been successfully removed.',
+			   'The categories have been successfully removed.',
+			   (int) $_GET['del']
+			   )
+			);
 }
 if (!empty($_GET['reord'])) {
-	dcPage::message(__('Categories have been successfully reordered.'));
-}
-if (!empty($_GET['moved'])) {
-	dcPage::message(__('The category has been successfully moved.'));
-}
-
-$rs = $core->blog->getCategories(array('post_type'=>'post'));
+	dcPage::success(__('Categories have been successfully reordered.'));
+}
 
 $categories_combo = array();
@@ -117,5 +139,5 @@
 	echo
 	'<form action="categories.php" method="post" id="form-categories">'.
-	'<h3>'.__('Categories list').'</h3>'.
+	'<h3>'.__('List of blog\'s categories').'</h3>'.
 	'<div id="categories">';
 
@@ -123,8 +145,5 @@
 	while ($rs->fetch())
 	{
-		$attr = 'id="cat'.$rs->cat_id.'"';
-		if ($rs->nb_total == 0) {
-			$attr .= ' class="deletable"';
-		}
+		$attr = 'id="cat_'.$rs->cat_id.'"';
 
 		if ($rs->level > $level) {
@@ -139,15 +158,11 @@
 
 		echo
-		'<p>';
-		if ($rs->nb_total == 0) {
-			echo form::checkbox(array('categories[]'),$rs->cat_id);
-		}
-
-		echo
-		'<strong><a href="category.php?id='.$rs->cat_id.'">'.html::escapeHTML($rs->cat_title).'</a></strong>'.
+		'<p>'.
+		form::checkbox(array('categories[]','cat-'.$rs->cat_id),$rs->cat_id,null,$rs->nb_total>0?'notempty':'').
+		'<label class="classic" for="cat-'.$rs->cat_id.'"><a href="category.php?id='.$rs->cat_id.'">'.html::escapeHTML($rs->cat_title).'</a></label>'.
 		' (<a href="posts.php?cat_id='.$rs->cat_id.'">'.
 		sprintf(($rs->nb_post > 1 ? __('%d entries') : __('%d entry') ),$rs->nb_post).'</a>'.
-		', '.__('total:').' '.$rs->nb_total.')</p>'.
-		'<p>'.__('URL:').' '.html::escapeHTML($rs->cat_url).'</p>';
+		', '.__('total:').' '.$rs->nb_total.') '.
+		'<span class="cat-url">'.__('URL:').' <code>'.html::escapeHTML($rs->cat_url).'</code></span></p>';
 
 		$level = $rs->level;
@@ -160,26 +175,41 @@
 	'</div>';
 
-	if (count($combo_action)>0) {
-		 echo
-		 '<div class="two-cols">'.
-		 '<p class="col checkboxes-helpers"></p>'.
-		 '<p class="col right"><label for="action" class="classic">'.__('Selected categories action:').'</label> '.
-		 form::combo('action',$combo_action).
-		 $core->formNonce().
-		 '<input type="submit" value="'.__('ok').'" /></p>'.
-		 '</div>'.
-		 '</form>';
-	}
-
-	echo
-	'<div class="col clear">'.
+	echo
+	'<div class="two-cols">'.
+	'<p class="col checkboxes-helpers"></p>'.
+	'<p class="col right" id="mov-cat">'.
+	'<label for="mov_cat" class="classic">'.__('Category which will receive entries of deleted categories:').'</label> '.
+	form::combo('mov_cat',array_merge(array(__('(No cat)') => ''),$categories_combo),'','').
+	'</p>'.
+	'<p class="right">'.
+	$core->formNonce().
+	'<input type="submit" value="'.__('Delete selected categories').'"/>'.
+	'</p>'.
+	'</div>'.
+	'</form>';
+
+	echo '<h3 class="clear">'.__('Categories order').'</h3>';
+
+	if ($core->auth->check('categories',$core->blog->id) && $rs->count()>1) {
+		echo
+		'<form action="categories.php" method="post">';
+		if (!$core->auth->user_prefs->accessibility->nodragdrop) {
+		        echo '<p class="no-js-hidden">'.__('To rearrange categories order, move items by drag and drop, then click on “Save categories order” button.').'</p>';
+		}
+		echo
+		'<p class="js-hidden">'.__('To rearrange categories order, change position number and click on “Save categories order” button.').'</p>'.
+		'<p>'.
+		'<input type="hidden" id="categories_order" name="categories_order" value=""/>'.
+		'<input type="submit" id="save-set-order" value="'.__('Save categories order').'" />'.
+		$core->formNonce().'</p>'.
+		'</form>';
+	}
+
+	echo
 	'<form action="categories.php" method="post" id="reset-order">'.
-	'<h3>'.__('Reorder categories').'</h3>'.
-	'<p>'.__('This will relocate all categories on the top level').'</p> '.
-	'<p><input class="reset" type="submit" value="'.__('Reorder').'" />'.
+	'<p><input type="submit" value="'.__('Reorder all categories on the top level').'" />'.
 	form::hidden(array('reset'),1).
 	$core->formNonce().'</p>'.
-	'</form>'.
-	'</div>';
+	'</form>';
 }
 
Index: admin/category.php
===================================================================
--- admin/category.php	(revision 1499)
+++ admin/category.php	(revision 1571)
@@ -176,5 +176,5 @@
 
 if (!empty($_GET['upd'])) {
-	dcPage::message(__('Category has been successfully updated.'));
+	dcPage::success(__('Category has been successfully updated.'));
 }
 
@@ -191,8 +191,8 @@
 	'<p><label for="new_cat_parent">'.__('Parent:').' '.
 	'<select id="new_cat_parent" name="new_cat_parent" >'.
-	'<option value="0">'.__('Top level').'</option>';
+	'<option value="0">'.__('(none)').'</option>';
 	while ($rs->fetch()) {
 		echo '<option value="'.$rs->cat_id.'" '.(!empty($_POST['new_cat_parent']) && $_POST['new_cat_parent'] == $rs->cat_id ? 'selected="selected"' : '').'>'.
-		str_repeat('&nbsp;&nbsp;',$rs->level).html::escapeHTML($rs->cat_title).'</option>';
+		str_repeat('&nbsp;&nbsp;',$rs->level-1).($rs->level-1 == 0 ? '' : '&bull; ').html::escapeHTML($rs->cat_title).'</option>';	
 	}
 	echo
Index: admin/comment.php
===================================================================
--- admin/comment.php	(revision 1399)
+++ admin/comment.php	(revision 1553)
@@ -188,5 +188,5 @@
 {
 	if (!empty($_GET['upd'])) {
-		dcPage::message(__('Comment has been successfully updated.'));
+		dcPage::success(__('Comment has been successfully updated.'));
 	}
 	
Index: admin/index.php
===================================================================
--- admin/index.php	(revision 1529)
+++ admin/index.php	(revision 1558)
@@ -226,7 +226,7 @@
 
 if ($core->blog->status == 0) {
-	echo '<p class="static-msg">'.__('This blog is offline').'</p>';
+	echo '<p class="static-msg">'.__('This blog is offline').'.</p>';
 } elseif ($core->blog->status == -1) {
-	echo '<p class="static-msg">'.__('This blog is removed').'</p>';
+	echo '<p class="static-msg">'.__('This blog is removed').'.</p>';
 }
 
@@ -340,5 +340,4 @@
 			? '<div>'.
 			'<p id="new_cat" class="q-cat">'.__('Add a new category').'</p>'.
-			'<p class="form-note info clear">'.__('This category will be created when you will save your post.').'</p>'.
 			'<p class="q-cat"><label for="new_cat_title">'.__('Title:').'</label> '.
 			form::field('new_cat_title',30,255,'','').'</p>'.
@@ -346,4 +345,5 @@
 			form::combo('new_cat_parent',$categories_combo,'','').
 			'</p>'.
+			'<p class="form-note info clear">'.__('This category will be created when you will save your post.').'</p>'.
 			'</div>'
 			: '').
Index: admin/install/index.php
===================================================================
--- admin/install/index.php	(revision 1399)
+++ admin/install/index.php	(revision 1553)
@@ -308,5 +308,5 @@
 
 if (!empty($_GET['wiz'])) {
-	echo '<p class="message">'.__('Configuration file has been successfully created.').'</p>';
+	echo '<p class="success">'.__('Configuration file has been successfully created.').'</p>';
 }
 
@@ -366,5 +366,5 @@
 	$plugins_install_result.
 	
-	'<p>'.__('Dotclear has been successfully installed. Here is some useful information you should keep.').'</p>'.
+	'<p class="success">'.__('Dotclear has been successfully installed. Here is some useful information you should keep.').'</p>'.
 	
 	'<h3>'.__('Your account').'</h3>'.
Index: admin/js/_categories.js
===================================================================
--- admin/js/_categories.js	(revision 1525)
+++ admin/js/_categories.js	(revision 1563)
@@ -1,4 +1,17 @@
-/* TODO: Some nice drag and drop on categories */
 $(function() {
+	if ($.fn['nestedSortable']!==undefined) {
+		$('#categories ul li').css('cursor','move');
+		$('#save-set-order').prop('disabled',true).addClass('disabled');
+		$('#categories ul').nestedSortable({
+			listType: 'ul',
+			items: 'li',
+			placeholder: 'placeholder',
+			update: function() {
+				$('#categories_order').attr('value',JSON.stringify($('#categories ul').nestedSortable('toArray')));
+				$('#save-set-order').prop('disabled',false).removeClass('disabled');
+			}
+		});
+	}
+
 	$('.checkboxes-helpers').each(function() {
 		dotclear.checkboxesHelpers(this);
Index: admin/js/_post.js
===================================================================
--- admin/js/_post.js	(revision 1529)
+++ admin/js/_post.js	(revision 1562)
@@ -115,5 +115,5 @@
 		// Confirm post deletion
 		$('input[name="delete"]').click(function() {
-			return window.confirm(dotclear.msg.confirm_delete_post);
+				return window.confirm(dotclear.msg.confirm_delete_post);
 		});
 
@@ -121,39 +121,31 @@
 		$('#notes-area label').toggleWithLegend($('#notes-area').children().not('label'),{
 			cookie: 'dcx_post_notes',
-		        hide: $('#post_notes').val() == '',
-		        legend_click: true
-		});
-		$('#new_cat').toggleWithLegend(
-			$('#new_cat').parent().children().not('#new_cat'),
-			{legend_click: true} // no cookie on new category as we don't use this every day
+			hide: $('#post_notes').val() == ''
+		});
+		$('#create_cat').toggleWithLegend(
+			$('#create_cat').parent().children().not('#create_cat'),
+			{} // no cookie on new category as we don't use this every day
 		);
 		$('#post_lang').parent().toggleWithLegend($('#post_lang'),{
-		    cookie: 'dcx_post_lang',
-		    legend_click: true
+			cookie: 'dcx_post_lang'
 		});
 		$('#post_password').parent().toggleWithLegend($('#post_password'),{
 			cookie: 'dcx_post_password',
-		    hide: $('#post_password').val() == '',
-		    legend_click: true
+			hide: $('#post_password').val() == ''
 		});
 		$('#post_status').parent().toggleWithLegend($('#post_status'),{
-		        cookie: 'dcx_post_status',
-		    legend_click: true
+			cookie: 'dcx_post_status'
 		});
 		$('#post_dt').parent().toggleWithLegend($('#post_dt').parent().children().not('label'),{
-		    cookie: 'dcx_post_dt',
-		    legend_click: true
+			cookie: 'dcx_post_dt'
 		});
 		$('#post_format').parent().toggleWithLegend($('#post_format').parent().children().not('label').add($('#post_format').parents('p').next()),{
-		    cookie: 'dcx_post_format',
-		    legend_click: true
+			cookie: 'dcx_post_format'
 		});
 		$('#cat_id').parent().toggleWithLegend($('#cat_id'),{
-		    cookie: 'cat_id',
-		    legend_click: true
+			cookie: 'cat_id'
 		});
 		$('#post_url').parent().toggleWithLegend($('#post_url').parent().children().not('label'),{
-		    cookie: 'post_url',
-		    legend_click: true
+			cookie: 'post_url'
 		});
 		// We load toolbar on excerpt only when it's ready
@@ -166,5 +158,5 @@
 		contentTb.switchMode(formatField.value);
 		excerptTb.switchMode(formatField.value);
-		
+
 		// Replace attachment remove links by a POST form submit
 		$('a.attachment-remove').click(function() {
Index: admin/js/common.js
===================================================================
--- admin/js/common.js	(revision 1525)
+++ admin/js/common.js	(revision 1576)
@@ -176,5 +176,5 @@
 		o.click(function() {
 			$(this).nextAll().each(function() {
-				if ($(this).is('h3')) {
+				if ($(this).is('h4')) {
 					return false;
 				}
@@ -196,6 +196,6 @@
 	this.find('>hr').remove();
 
-	this.find('h3').each(function() { textToggler($(this)); });
-	this.find('h3:first').nextAll('*:not(h3)').hide();
+	this.find('h4').each(function() { textToggler($(this)); });
+	this.find('h4:first').nextAll('*:not(h4)').hide();
 	sizeBox();
 
@@ -246,4 +246,7 @@
 
 	checkboxesHelpers: function(e) {
+		$(e).append(document.createTextNode(dotclear.msg.to_select));
+		$(e).append(document.createTextNode(' '));
+
 		var a = document.createElement('a');
 		a.href='#';
@@ -255,5 +258,5 @@
 		$(e).append(a);
 
-		$(e).append(document.createTextNode(' - '));
+		$(e).append(document.createTextNode(' | '));
 
 		a = document.createElement('a');
@@ -301,20 +304,10 @@
 	categoriesActionsHelper: function() {
 		$('#form-categories').submit(function() {
-			var action = $(this).find('select[name="action"]').val();
-			var checked = false;
-
-			$(this).find('input[name="categories[]"]').each(function() {
-				if (this.checked) {
-					checked = true;
-				}
-			});
-
-			if (!checked) { return false; }
-
-			if (action == 'delete') {
-				return window.confirm(dotclear.msg.confirm_delete_categories.replace('%s',$('input[name="categories[]"]:checked').size()));
-			}
-
-			return true;
+		    var nb_ckecked = $('input[name="categories[]"]:checked').length;
+		    if (nb_ckecked==0) {
+			return false;
+		    }
+
+		    return window.confirm(dotclear.msg.confirm_delete_categories.replace('%s',nb_ckecked));
 		});
 	},
@@ -345,4 +338,7 @@
 -------------------------------------------------------- */
 $(function() {
+	// remove class no-js from html tag
+	$('html').removeClass('no-js');
+
 	// Blog switcher
 	$('#switchblog').change(function() {
@@ -373,4 +369,5 @@
 	$('.message').backgroundFade({sColor:'#cccccc',eColor:'#666666',steps:20});
 	$('.error').backgroundFade({sColor:'#ffdec8',eColor:'#ffbaba',steps:20});
+	$('.success').backgroundFade({sColor:'#91ff4d',eColor:'#baff8e',steps:20});
 
 	$('form:has(input[type=password][name=your_pwd])').submit(function() {
